package eu.etaxonomy.taxeditor;

import org.eclipse.ui.application.IWorkbenchConfigurer;
import org.eclipse.ui.application.IWorkbenchWindowConfigurer;
import org.eclipse.ui.application.WorkbenchAdvisor;
import org.eclipse.ui.application.WorkbenchWindowAdvisor;


/**
 * <p>ApplicationWorkbenchAdvisor class.</p>
 *
 * @author n.hoffmann
 * @version $Id: $
 */
public class ApplicationWorkbenchAdvisor extends WorkbenchAdvisor {

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.application.WorkbenchAdvisor#createWorkbenchWindowAdvisor(org.eclipse.ui.application.IWorkbenchWindowConfigurer)
	 */
	/** {@inheritDoc} */
	public WorkbenchWindowAdvisor createWorkbenchWindowAdvisor(
			IWorkbenchWindowConfigurer configurer) {
		return new ApplicationWorkbenchWindowAdvisor(configurer);
	}

	
	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.application.WorkbenchAdvisor#getInitialWindowPerspectiveId()
	 */
	/**
	 * <p>getInitialWindowPerspectiveId</p>
	 *
	 * @return a {@link java.lang.String} object.
	 */
	public String getInitialWindowPerspectiveId() {
		return "eu.etaxonomy.taxeditor.application.perspective.taxonomic";
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.application.WorkbenchAdvisor#initialize(org.eclipse.ui.application.IWorkbenchConfigurer)
	 */
	/** {@inheritDoc} */
	public void initialize(IWorkbenchConfigurer configurer) {
		super.initialize(configurer);
				
		// Remembers the user's view layout, window size, window location etc.
		//  for the next time application is started
		configurer.setSaveAndRestore(true);
	}	
	
	/* (non-Javadoc)
	 * @see org.eclipse.ui.application.WorkbenchAdvisor#preStartup()
	 */
	/** {@inheritDoc} */
	@Override
	public void preStartup() {
		// TODO Auto-generated method stub
		super.preStartup();
		// XXX check for updates before starting up.
    	// If an update is performed, restart.
//    	if (P2Util.checkForUpdates())
//    		PlatformUI.getWorkbench().restart();
	}
	
/**
 * see:	https://bugs.eclipse.org/bugs/show_bug.cgi?id=234252
 */
//	public void initialize(IWorkbenchConfigurer configurer) {
//
//		WorkbenchAdapterBuilder.registerAdapters();
//
//		final String ICONS_PATH = "icons/full/";
//		final String PATH_OBJECT = ICONS_PATH + "obj16/";
//		Bundle ideBundle = Platform.getBundle(IDEWorkbenchPlugin.IDE_WORKBENCH);
//		declareWorkbenchImage(configurer, ideBundle,
//				IDE.SharedImages.IMG_OBJ_PROJECT, PATH_OBJECT + "prj_obj.gif",
//				true);
//		declareWorkbenchImage(configurer, ideBundle,
//				IDE.SharedImages.IMG_OBJ_PROJECT_CLOSED, PATH_OBJECT
//						+ "cprj_obj.gif", true);
//
//	}
//
//	private void declareWorkbenchImage(IWorkbenchConfigurer configurer_p,
//			Bundle ideBundle, String symbolicName, String path, boolean shared) {
//		URL url = ideBundle.getEntry(path);
//		ImageDescriptor desc = ImageDescriptor.createFromURL(url);
//		configurer_p.declareImage(symbolicName, desc, shared);
//	}
//
//	public IAdaptable getDefaultPageInput() {
//		IWorkspace workspace = ResourcesPlugin.getWorkspace();
//		return workspace.getRoot();
//	}

	

}
